PostgreSQL 9.1beta2 Documentation
Prev | Fast Backward |  | Fast Forward | Next

# pg_basebackup

## Name

pg_basebackup -- take a base backup of a PostgreSQL cluster

## Synopsis

`pg_basebackup` [`option`...]

## Description

pg_basebackup is used to take base backups of a running PostgreSQL database cluster. These are taken without affecting other clients to the database, and can be used both for point-in-time recovery (see Section 24.3) and as the starting point for a log shipping or streaming replication standby servers (see Section 25.2).

pg_basebackup makes a binary copy of the database cluster files, while making sure the system is automatically put in and out of backup mode automatically. Backups are always taken of the entire database cluster, it is not possible to back up individual databases or database objects. For individual database backups, a tool such as pg_dump must be used.

The backup is made over a regular PostgreSQL connection, and uses the replication protocol. The connection must be made with a user having `REPLICATION` permissions (see Section 20.2), and the user must be granted explicit permissions in `pg_hba.conf`. The server must also be configured with max_wal_senders set high enough to leave at least one session available for the backup.

There can be multiple `pg_basebackup`s running at the same time, but it is better from a performance point of view to take only one backup, and copy the result.

## Options

The following command-line options control the location and format of the output.

`-D `directory``
`--pgdata=`directory``

  Directory to write the output to.

  When the backup is in tar mode, and the directory is specified as `-` (dash), the tar file will be written to `stdout`.

  This parameter is required.

`-F `format``
`--format=`format``

  Selects the format for the output. `format` can be one of the following:

  `p`
  `plain`

    Write the output as plain files, with the same layout as the current data directory and tablespaces. When the cluster has no additional tablespaces, the whole database will be placed in the target directory. If the cluster contains additional tablespaces, the main data directory will be placed in the target directory, but all other tablespaces will be placed in the same absolute path as they have on the server.

    This is the default format.

  `t`
  `tar`

    Write the output as tar files in the target directory. The main data directory will be written to a file named `base.tar`, and all other tablespaces will be named after the tablespace OID.

    If the value `-` (dash) is specified as target directory, the tar contents will be written to standard output, suitable for piping to for example gzip. This is only possible if the cluster has no additional tablespaces.

`-x`
`--xlog`

  Includes the required transaction log files (WAL files) in the backup. This will include all transaction logs generated during the backup. If this option is specified, it is possible to start a postmaster directly in the extracted directory without the need to consult the log archive, thus making this a completely standalone backup.

  > Note: The transaction log files are collected at the end of the backup. Therefore, it is necessary for the wal_keep_segments parameter to be set high enough that the log is not removed before the end of the backup. If the log has been rotated when it's time to transfer it, the backup will fail and be unusable.

`-z`
`--gzip`

  Enables gzip compression of tar file output, with the default compression level. Compression is only available when using the tar format.

`-Z `level``
`--compress=`level``

  Enables gzip compression of tar file output, and specifies the compression level (1 through 9, 9 being best compression). Compression is only available when using the tar format.

The following command-line options control the generation of the backup and the running of the program.

`-c `fast|spread``
`--checkpoint=`fast|spread``

  Sets checkpoint mode to fast or spread (default).

`-l `label``
`--label=`label``

  Sets the label for the backup. If none is specified, a default value of `pg_basebackup base backup` will be used.

`-P`
`--progress`

  Enables progress reporting. Turning this on will deliver an approximate progress report during the backup. Since the database may change during the backup, this is only an approximation and may not end at exactly `100%`. In particular, when WAL log is included in the backup, the total amount of data cannot be estimated in advance, and in this case the progress report will only count towards the total amount of data without WAL.

  When this is enabled, the backup will start by enumerating the size of the entire database, and then go back and send the actual contents. This may make the backup take slightly longer, and in particular it will take longer before the first data is sent.

`-v`
`--verbose`

  Enables verbose mode. Will output some extra steps during startup and shutdown, as well as show the exact file name that is currently being processed if progress reporting is also enabled.

The following command-line options control the database connection parameters.

`-h `host``
`--host=`host``

  Specifies the host name of the machine on which the server is running. If the value begins with a slash, it is used as the directory for the Unix domain socket. The default is taken from the `PGHOST` environment variable, if set, else a Unix domain socket connection is attempted.

`-p `port``
`--port=`port``

  Specifies the TCP port or local Unix domain socket file extension on which the server is listening for connections. Defaults to the `PGPORT` environment variable, if set, or a compiled-in default.

`-U `username``
`--username=`username``

  User name to connect as.

`-w`
`--no-password`

  Never issue a password prompt. If the server requires password authentication and a password is not available by other means such as a `.pgpass` file, the connection attempt will fail. This option can be useful in batch jobs and scripts where no user is present to enter a password.

`-W`
`--password`

  Force pg_basebackup to prompt for a password before connecting to a database.

  This option is never essential, since pg_bsaebackup will automatically prompt for a password if the server demands password authentication. However, pg_basebackup will waste a connection attempt finding out that the server wants a password. In some cases it is worth typing `-W` to avoid the extra connection attempt.

Other, less commonly used, parameters are also available:

`-V`
`--version`

  Print the pg_basebackup version and exit.

`-?`
`--help`

  Show help about pg_basebackup command line arguments, and exit.

## Environment

This utility, like most other PostgreSQL utilities, uses the environment variables supported by libpq (see Section 31.13).

## Notes

The backup will include all files in the data directory and tablespaces, including the configuration files and any additional files placed in the directory by third parties. Only regular files and directories are allowed in the data directory, no symbolic links or special device files.

The way PostgreSQL manages tablespaces, the path for all additional tablespaces must be identical whenever a backup is restored. The main data directory, however, is relocatable to any location.

## Examples

To create a base backup of the server at `mydbserver` and store it in the local directory `/usr/local/pgsql/data`:

    $ pg_basebackup -h mydbserver -D /usr/local/pgsql/data

To create a backup of the local server with one compressed tar file for each tablespace, and store it in the directory `backup`, showing a progress report while running:

    $ pg_basebackup -D backup -Ft -z -P

To create a backup of a single-tablespace local database and compress this with bzip2:

    $ pg_basebackup -D - -Ft | bzip2 > backup.tar.bz2

(This command will fail if there are multiple tablespaces in the database.)

## See Also

pg_dump

Prev | Home | Next
ecpg | Up | pg_config